const deviceSn = '1923MW000058';
const deviceSecret = '2Pqb2rHY7vM8I4Cy2QwyC7vzhTwruYTk';
const baseUrl = 'https://gateway-beta.mingwork.com/'
const currentDate = new Date();
const expiresDate = new Date();


//第一次登录，登录过期
async function keepAccessTokenValid(){
    if(!window.localStorage.access_token || (window.localStorage.access_token && currentDate.getTime() >= window.localStorage.expiresDate)){
      await getAccessToken();
    }   
}

async function getAccessToken(){
    const data = {deviceSn, deviceSecret};
    await fetch(baseUrl + 'auth/authentication/device', {
        method: 'POST',
        cache: 'no-cache',
        headers: {
          'Authorization': `Basic bWVldGluZy13ZWI6bWVldGluZy13ZWI`,
          'Content-Type': 'application/x-www-form-urlencoded;charset=utf-8'
        },
        body: Object.keys(data).map(key => `${key}=${data[key]}`).join('&')
    })
    .then(res => res.json()).then(res => {
        expiresDate.setSeconds(currentDate.getSeconds() + res.expires_in);
        window.localStorage.access_token = res.access_token;
        window.localStorage.expiresDate = expiresDate.getTime();
    })
}

function post(url, data, options) {
    const opts = {
        ...options,
        method: 'POST',
        cache: 'no-cache',
        headers: {
        'Accept': 'application/json',
        'Content-Type': 'application/json'
        },
        body: JSON.stringify(data)
    };
    return xFetch(url, opts);
}

function postForm(url, data, options) {
    const opts = {
      ...options,
      method: 'POST',
      cache: 'no-cache',
      headers: {
        'Content-Type': 'application/x-www-form-urlencoded;charset=utf-8'
      },
      body: Object.keys(data).map(key => `${key}=${data[key]}`).join('&')
    };
    return xFetch(url, opts);
}
function get(url, options) {
    return xFetch(url, options);
}
function getWithArgs(url, args, options) {
    args = args || {};
    for (const attr in args) {
        if (args[attr] === undefined || args[attr] === null) {
        delete args[attr];
        }
    }
    const keys = Object.keys(args).map(key => `${key}=${args[key]}`).join('&');
    url = url + '?' + keys;
    return xFetch(url, options);
}

function check401(res) {
    if (res.status === 401) {
        window.localStorage.clear();
        keepAccessTokenValid();
        return Promise.reject(res);
    }
    return res;
}
async function xFetch(url, options) {
    await keepAccessTokenValid();
    const opts = {...options};
    opts.headers = {
     ...opts.headers,
     'Authorization': `Bearer ${window.localStorage.access_token}`,  
    };
    return (
      fetch(baseUrl + url, opts)
        .then(check401)
        .then(res => res.json()).then(res => {
            return res
        })
    );
}
  

