const iWidth = document.documentElement.clientWidth;
document.getElementsByTagName('html')[0].style.fontSize = 100 * iWidth / 1920 + 'px';   

let currentPage = 'listPage';
let loadingPage = 'loading1'

setDate();
setTime();
setTimeout(() => {
  setTime();
  setInterval(setTime, 60000);
}, (60 - currentDate.getSeconds())*1000);

function setDate(){
    if($('#nowDate')){
        $('#nowDate').html(formatDate(currentDate, 'MM' + '月' + 'dd' + '日'));
    }
}
function setTime(){
  $('.nowTime').html(formatDate(new Date(), 'HH:mm'))
  if(new Date().getDate() !== currentDate.getDate()){
    setDate();
  }
  if(currentPage == 'listPage'){
    getRoomList();
  } 
}
function formatDate(time, format){  
    var t = new Date(time);  
    var tf = function(i){return (i < 10 ? '0' : '') + i};  
    return format.replace(/yyyy|MM|dd|HH|mm|ss/g, function(a){  
        switch(a){  
            case 'yyyy':  
                return tf(t.getFullYear());  
                break;  
            case 'MM':  
                return tf(t.getMonth() + 1);  
                break;  
            case 'mm':  
                return tf(t.getMinutes());  
                break;  
            case 'dd':  
                return tf(t.getDate());  
                break;  
            case 'HH':  
                return tf(t.getHours());  
                break;  
            case 'ss':  
                return tf(t.getSeconds());  
                break;  
        }  
    })  
};


async function getRoomList(){
  const res = await post('meet/meeting-room/getMeetingRoomScheduleList', 
  {deviceSn:deviceSn, startTime: formatDate(new Date(), 'yyyy-MM-dd 00:00:00'),endTime: formatDate(new Date(), 'yyyy-MM-dd 23:59:59')});
  
  if(!res.data){
     res.data = {meetingList: [], fullName: '', name:''}
  }
  
  $('#address').html(res.data.fullName  + res.data.name);

  let str = ''
  let getOne = false;
  let codeBlockRow = 0;
  const meetingListOrigin = (res.data.meetingList || []).sort(sortByStartTime);
  let meetingList = [];
  //过时的不要了
  for(let i =0; i < meetingListOrigin.length; i++){
    
    if(isTimeAvalible(meetingListOrigin[i].endTime)){
      meetingList = meetingListOrigin.splice(i, 3)
      break;
    }
  }

  if (meetingList.length == 0) {
    str += '<div data-index="0-0, 0-1" data-method="showHelp" class="li exclued-after">\n' +
    '    <div class="left-avatar left-company"></div>\n' +
    '    <div class="right-content">\n' +
    '       <div class="time free-time">空闲会议室</div>\n' +
    '       <div class="introduce">钉钉工作台，明我会议室预约</div>\n' +
    '    </div>\n' +
    '    </div>';
    codeBlockRow = 1;
  } else {
    meetingList.forEach((it, index) => {
      const organizerInfo = it.creator || {};
      const name = organizerInfo.headUrl ? '' : organizerInfo.username.slice(-2);
      let className = 'li';
      if(isTimeInRange(it.startTime, it.endTime) && !getOne){
        getOne = true;
        
        className += ' high-light';
      } 
      if(index === meetingList.length -1){
        className += ' exclued-after'
      }
      str += '<div data-index="'+index+'-0,'+index+'-1" class="'+className+'" data-id="'+it.id+'" data-username="'+organizerInfo.username+'" data-method="showDetail">\n' +
        '                    <div class="left-avatar" style="background-image: url('+organizerInfo.headUrl+')">'+name+'</div>\n' +
        '                    <div class="right-content">\n' +
        '                        <div class="time">'+ it.startTime.substring(11,16)+' ~ '+it.endTime.substring(11,16)+'</div>\n' +
        '                        <div class="introduce">'+organizerInfo.username+' - '+it.title+'</div>\n' +
        '                    </div>\n' +
        '                </div>'
    })
    codeBlockRow = meetingList.length;

  }
  str += '<div class="li exclued-after code-li">\n' +
  '   <div data-index="'+codeBlockRow+'-0" data-method="showHelp">\n' +
  '     <div class="top-code"></div>\n' +
  '     <div class="bottom-content">\n' +
  '         扫码预定\n' +
  '      </div>   \n' +
  '  </div>\n' +
  '  <div data-index="'+codeBlockRow+'-1" data-method="startZoom">\n' +
  '      <div class="top-zoom"></div>\n' +
  '     <div class="bottom-content">\n' +
  '          加入ZOOM会议\n' +
  '      </div>   \n' +
  '   </div>\n' +
  '  </div>'
  document.getElementById('listBox').innerHTML = str; 
  generateFocusMap('listBox') 
}
function isTimeInRange(startTime, endTime){
  return new Date(startTime.replace(/-/g, '/')).getTime() - new Date().getTime() <= 15*60*1000 && new Date(endTime.replace(/-/g, '/')).getTime() - new Date().getTime() >= 0
}
function isTimeAvalible(endTime){
  return new Date(endTime.replace(/-/g, '/')).getTime() > new Date().getTime()
}
function sortByStartTime(a,b){
  return new Date(a.startTime.replace(/-/g, '/')).getTime() - new Date(b.startTime.replace(/-/g, '/')).getTime();
}
async function getMeetingDetail(id){
  console.log('scheduleId: ' +　id)
  const res = await post('meet/meeting-room/getMeetingRoomScheduleDetail', {scheduleId:id});
  if(res.code != 0){
    console.log(res.msg)
    return
  }
  const schedule = res.data.schedule || {};
  $('#scheduleTitle').html(schedule.title)
  $('#scheduleRemark').show().html(schedule.remark);
  document.getElementById('scheduleInfo').innerHTML = '<span>'+ schedule.startTime.substring(11,16)+' ~ '+ schedule.endTime.substring(11,16)+'</span>/<span>'+window.localStorage.username+'</span>/<span>'+res.data.fullName+'</span>';

  // 加入ZOOM会议
  if(schedule.meetingWay.includes('zoom')){
    $('#zoomMeeting').show();
    if(schedule.meetingWayModel.data){
      const model = schedule.meetingWayModel.data.meetingId +　'||' + schedule.meetingWayModel.data.password;
      $('#zoomMeeting').html('<div data-index="0-0, 0-1, 0-2" class="high-light" data-method="joingZoom" data-model="'+model+'">加入ZOOM会议</div>')
    } else {
      $('#zoomMeeting').html('<div data-index="0-0, 0-1, 0-2" class="high-light" data-method="startZoom">加入ZOOM会议</div>')
    }
  }else{
    $('#zoomMeeting').hide();
  }
  // 文件列表
  const resourceList = res.data.meetingResourceList || [];
  let fileList = [];
  if(resourceList.length > 0){
    resourceList.forEach(it => {
      const fileInfos = it.fileInfos ? JSON.parse(it.fileInfos) : [];
      fileInfos.forEach(item => {
        fileList.push({
          fileInfos: item,
          creatorInfo: it.creatorInfo ? JSON.parse(it.creatorInfo) : {}
        })
      })
    })
  }
  let str2 = '';
  if (fileList.length > 0){
      $('#meetingResourceList').show();
      document.getElementById('fileListNum').innerHTML = '（' + fileList.length + '）';

      fileList.forEach((it, index) => {
          const row = Math.ceil((index+1)/3);
          const col = index % 3;
          let className = 'file-box';
          // zoom按钮没有时高亮第一个文件
          if(index === 0 && !schedule.meetingWay.includes('zoom')){
            className += ' high-light'
          }
          str2 += '<div data-index="'+row+'-'+col+'" class="'+className+'" data-method="previewFile" data-fileId="'+it.fileInfos.fileId+'">\n' +
          '                <div class="file-icon '+it.fileInfos.fileType+' "></div>\n' +
          '                <div class="file-content">\n' +
          '                    <div class="file-name">'+it.fileInfos.fileName+'</div>\n' +
          // '                    <div class="file-size">'+(fileInfos.fileSize/1024/1024).toFixed(2)+' M</div>\n' +
          '                    <div class="file-size">由'+it.creatorInfo.username+'上传</div>\n' +
          '                </div>\n' +
          '            </div>'
      })
  }else{
    $('#meetingResourceList').hide();
  }

  document.getElementById('fileList').innerHTML = str2;
  
  //参会人列表
  const scheduleUserMappings = schedule.scheduleUserMappings || [];
  if (scheduleUserMappings.length > 0 )　{
      let basicRow = Math.ceil(fileList.length/3);
      document.getElementById('scheduleUserMappings').style.display = 'block';
      document.getElementById('scheduleUsersNum').innerHTML = '（' + scheduleUserMappings.length + '）';
      let str = '';
      scheduleUserMappings.forEach((it, index) => {
       　 let className = 'people-block';
          // zoom按钮没有时高亮,文件没有高亮
          if(index == 0 &&　fileList.length === 0 && !schedule.meetingWay.includes('zoom')){
            className += ' high-light'
          }
          const row = basicRow + Math.ceil((index+1)/11);
          const col = index % 11;
          const userInfo = it.userInfo ? JSON.parse(it.userInfo) : {organizerName: ''};
          const name = userInfo.headUrl ? '' : userInfo.organizerName.slice(-2);
          str += '<div data-index="'+row+'-'+col+'" class="'+className+'">\n' +
          '                <div  class="avatar" style="background-image: url('+userInfo.headUrl+')">'+name+'</div>\n' +
          '                <div class="name">'+userInfo.organizerName+'</div>\n' +
          '            </div>'
      });
      document.getElementById('scheduleUsersList').innerHTML = str;
  }
  generateFocusMap('detail') 

}

let focusElementMap = {};
const focusState = {currentRowIndex: 0, currentColIndex: 0 };

function generateFocusMap(id){
  focusElementMap = null;
  focusElementMap = {};
  $('#'+id+' div[data-index]').each(function(){
    const indexArrAll = $(this).attr('data-index').split(/,\s*/);
    indexArrAll.forEach(it => {
        focusElementMap[it] = $(this);
    })    
    if($(this).hasClass('high-light')){
        const indexArr = $(this).attr('data-index').split(/,\s*/)[0].split('-')
        focusState.currentRowIndex = indexArr[0];
        focusState.currentColIndex = indexArr[1];
    }     
 });
}

function setFocus(){
  for(item in focusElementMap){
    if(item.hasClass('high-light')){
      const indexArr = $(this).attr('data-index').split(/,\s*/)[0].split('-');
      focusState.currentRowIndex = indexArr[0];
      focusState.currentColIndex = indexArr[1];
    }
  }
}

function removeFocus(){
    focusElementMap[focusState.currentRowIndex + '-' + focusState.currentColIndex].removeClass('high-light')
}
function setShake(){
  console.log('setShake')
  focusElementMap[focusState.currentRowIndex + '-' + focusState.currentColIndex].addClass('shake')
  setTimeout(function(){
    focusElementMap[focusState.currentRowIndex + '-' + focusState.currentColIndex].removeClass('shake')
  },500)
}
function moveLeft(){     
    let rowIndex = focusState.currentRowIndex;
    let colIndex = focusState.currentColIndex - 1;
    let indexString = [rowIndex, colIndex].join("-");
    if(focusElementMap[indexString]){
        removeFocus();
        focusElementMap[indexString].addClass('high-light');
        focusState.currentColIndex = colIndex;
    }else{
        setShake()
    }
}

function moveRight(){  
    let rowIndex = focusState.currentRowIndex;
    let colIndex = Number(focusState.currentColIndex) + 1;
    let indexString = [rowIndex, colIndex].join("-");
    console.log(indexString)
    if(focusElementMap[indexString]){
        removeFocus();
        focusElementMap[indexString].addClass('high-light');
        focusState.currentColIndex = colIndex;
    }else{
      setShake()
    }
}

function moveDown(){
    let rowIndex = Number(focusState.currentRowIndex) + 1;
    let colIndex = focusState.currentColIndex;
    let indexString = [rowIndex, colIndex].join("-");
    console.log(indexString)
    if(focusElementMap[indexString]){
        removeFocus();
        focusElementMap[indexString].addClass('high-light');
        focusState.currentRowIndex = rowIndex;
    }else{
      setShake()
    }
}

function moveUp(){
    let rowIndex = Number(focusState.currentRowIndex) - 1;
    let colIndex = focusState.currentColIndex;
    let indexString = [rowIndex, colIndex].join("-");
    console.log(indexString)
    if(focusElementMap[indexString]){
        removeFocus();
        focusElementMap[indexString].addClass('high-light');
        focusState.currentRowIndex = rowIndex;
    }else{
      setShake()
    }
}

function enter(){

  if(loadingPage == 'loading1'){
    $('#loading1').hide();
    loadingPage = 'loading2'
    return
  }
 if(loadingPage == 'loading2'){
    $('#loading2').hide();
    loadingPage = ''
    return
  }
  const rowIndex = focusState.currentRowIndex;
  const colIndex = focusState.currentColIndex;
  const indexString = [rowIndex, colIndex].join("-");
  if(focusElementMap[indexString].hasClass('high-light')){
    const method = focusElementMap[indexString].attr('data-method');
    if (method == 'showHelp') {
      showHelpPage()
    }
    else if(method == 'showDetail'){
      const id = focusElementMap[indexString].attr('data-id');
      const username = focusElementMap[indexString].attr('data-username');
      window.localStorage.meetingId = id;
      window.localStorage.username = username;
      showDetailPage()
      getMeetingDetail(id)
     
    }
    else if(method == 'previewFile') {
      if(window.android &&　window.android.back){
        window.android.back('intercept')
      }
      get('meet/meeting-log-resource/generateIDocViewFileUrl?fileId='+ focusElementMap[indexString].attr('data-fileId')).then(res => {
        if(res.code == 0){
          window.open(res.data, '_self');
        }
      })
         
    }
    else if(method == 'joingZoom'){
      console.log('joingZoom')
      const model = focusElementMap[indexString].attr('data-model').split('||');
      if(window.android &&　window.android.joinMeetingRoom){
        window.android.joinMeetingRoom(model[0], model[1])
      }
    }
    else if(method == 'startZoom'){
      console.log('startZoom')
      if(window.android &&　window.android.startZoomMeeting){
        window.android.startZoomMeeting()
      }
    }
    
  } 
}

function esc(){
  if(currentPage == 'helpPage') {
    showListPageFromHelpPage();
    generateFocusMap('listBox')
  }
  else if(currentPage == 'detailPage'){
    showListPage();
    generateFocusMap('listBox')
  }
}

document.onkeydown = function(event){
  const e = event || window.event || arguments.callee.caller.arguments[0];
  if(e.keyCode == 37){
      if(loadingPage){
        return
      }
      moveLeft();
  }
  
  else if(e.keyCode == 39){
    if(loadingPage){
      return
    }
      moveRight();
  }

  else if(e.keyCode == 40){
    if(loadingPage){
      return
    }
      moveDown();
  }
  else if(e.keyCode == 38){
    if(loadingPage){
      return
    }
      moveUp();
  }
  else if(e.keyCode == 13){
    enter();
  }
  else if(e.keyCode == 27){
    if(loadingPage){
      return
    }
    esc();
  }
}


if(window.android && window.android.isPreviewPage()){
  showDetailPage();
  getMeetingDetail(window.localStorage.meetingId);
  //测试
  setTimeout(function(){
    console.log('重新生成FocusMap')
    generateFocusMap('detail');
  }, 500)

} else{
  showListPage()
}

function showDetailPage(){
  $('#loading1').hide();
  $('#loading2').hide();
  loadingPage = '';
  document.getElementById('list').style.display = 'none';
  document.getElementById('detail').style.display = 'block';
  currentPage = 'detailPage';
}

function showListPage(){
  document.getElementById('detail').style.display = 'none';      
  document.getElementById('list').style.display = 'flex';
  currentPage = 'listPage';
}

function showHelpPage(){
  document.getElementById('listContent').style.display = 'none';      
  document.getElementById('helpContent').style.display = 'flex';
  currentPage = 'helpPage';
}

function showListPageFromHelpPage(){
  document.getElementById('listContent').style.display = 'flex';      
  document.getElementById('helpContent').style.display = 'none';
  currentPage = 'listPage';
}
async function reload(){
  await getRoomList();
  if(currentPage == 'detailPage'){
    await getMeetingDetail(window.localStorage.meetingId)
  } 
}
